package mega.privacy.android.app.listeners;

import android.content.Context;
import android.content.Intent;
import android.os.Handler;

import mega.privacy.android.app.MegaApplication;
import mega.privacy.android.app.R;
import mega.privacy.android.app.lollipop.ManagerActivity;
import mega.privacy.android.app.utils.Util;
import nz.mega.sdk.MegaApiJava;
import nz.mega.sdk.MegaError;
import nz.mega.sdk.MegaRequest;

import static mega.privacy.android.app.constants.BroadcastConstants.ACTION_RESET_VERSION_INFO_SETTING;

public class RemoveVersionsListener extends BaseListener {

    public RemoveVersionsListener(Context context) {
        super(context);
    }

    @Override
    public void onRequestFinish(MegaApiJava api, MegaRequest request, MegaError e) {
        if (request.getType() != MegaRequest.TYPE_REMOVE_VERSIONS) return;

        if (e.getErrorCode() == MegaError.API_OK) {
            Util.showSnackbar(context, context.getString(R.string.success_delete_versions));
            MegaApplication.getInstance().sendBroadcast(new Intent(ACTION_RESET_VERSION_INFO_SETTING));
            if (context instanceof ManagerActivity) {
                final Handler handler = new Handler();
                handler.postDelayed(() -> ((ManagerActivity) context).updateAccountStorageInfo(), 8000);
            }
        } else {
            Util.showSnackbar(context, context.getString(R.string.error_delete_versions));
        }
    }
}